Subject: bug#56003: Bash functions not showing in speedbar

From: Visuwesh <[email-masked]>
Date: Thu, 16 Jun 2022 08:41:12 +0530

[வியாழன் ஜூன் 16, 2022 02:12] carlmarcos--- via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Have been working on some functionalities implemented in bash.  But looking at the speedbar, only some function
> names are being listed.  Tried to see whether a bug-report has been previously submitted, but could not find any. 
> Have found the search feature for the archives quite challenging to use.
>
> Carl

You need to add a relevant bash entry to `sh-imenu-generic-expression'.
I would propose a patch but the bash manual is vague about the allowed
characters, and I never use bash so I'm not interested in digging
further.  Maybe the newly added mksh entry could be a good example,

    (mksh
     . ((nil
         ;; function FOO
         ;; function FOO()
         ,(rx bol (* (syntax whitespace)) "function" (+ (syntax whitespace))
              (group (1+ (not (any "\0\t\n \"$&'();<=>\\`|#*?[]/"))))
              (* (syntax whitespace)) (? "()"))
         1)
        (nil
         ;; FOO()
         ,(rx bol (* (syntax whitespace))
              (group (1+ (not (any "\0\t\n \"$&'();<=>\\`|#*?[]/"))))
              (* (syntax whitespace)) "()")
         1)))

HTH.